]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test-lib.sh: colors to test output when parallel(1) is run on tty
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98
99 # Protect ourselves from common misconfiguration to export
100 # CDPATH into the environment
101 unset CDPATH
102
103 unset GREP_OPTIONS
104
105 # For emacsclient
106 unset ALTERNATE_EDITOR
107
108 add_gnupg_home ()
109 {
110     local output
111     [ -d ${GNUPGHOME} ] && return
112     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
113     at_exit_function _gnupg_exit
114     mkdir -m 0700 "$GNUPGHOME"
115     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
116     test_debug "cat $GNUPGHOME/import.log"
117     if (gpg --quick-random --version >/dev/null 2>&1) ; then
118         echo quick-random >> "$GNUPGHOME"/gpg.conf
119     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
120         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
121     fi
122     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
123
124     # Change this if we ship a new test key
125     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
126     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
127     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
128 }
129
130 # Each test should start with something like this, after copyright notices:
131 #
132 # test_description='Description of this test...
133 # This test checks if command xyzzy does the right thing...
134 # '
135 # . ./test-lib.sh || exit 1
136
137 color=maybe
138
139 while test "$#" -ne 0
140 do
141         case "$1" in
142         -d|--debug)
143                 debug=t; shift ;;
144         -i|--immediate)
145                 immediate=t; shift ;;
146         -h|--help)
147                 help=t; shift ;;
148         -v|--verbose)
149                 verbose=t; shift ;;
150         -q|--quiet)
151                 quiet=t; shift ;;
152         --with-dashes)
153                 with_dashes=t; shift ;;
154         --no-color)
155                 color=; shift ;;
156         --no-python)
157                 # noop now...
158                 shift ;;
159         --valgrind)
160                 valgrind=t; verbose=t; shift ;;
161         --tee)
162                 shift ;; # was handled already
163         *)
164                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
165         esac
166 done
167
168 if test -n "$debug"; then
169     print_subtest () {
170         printf " %-4s" "[$((test_count - 1))]"
171     }
172 else
173     print_subtest () {
174         true
175     }
176 fi
177
178 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
179
180 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
181                 TERM=$ORIGINAL_TERM &&
182                 export TERM &&
183                 tput bold
184                 tput setaf
185                 tput sgr0
186         ) >/dev/null 2>&1
187 then
188         color=t
189 else
190         color=
191 fi
192
193 if test -n "$color"; then
194         say_color () {
195                 (
196                 TERM=$ORIGINAL_TERM
197                 export TERM
198                 case "$1" in
199                         error) tput bold; tput setaf 1;; # bold red
200                         skip)  tput bold; tput setaf 2;; # bold green
201                         pass)  tput setaf 2;;            # green
202                         info)  tput setaf 3;;            # brown
203                         *) test -n "$quiet" && return;;
204                 esac
205                 shift
206                 printf " "
207                 printf "$@"
208                 tput sgr0
209                 print_subtest
210                 )
211         }
212 else
213         say_color() {
214                 test -z "$1" && test -n "$quiet" && return
215                 shift
216                 printf " "
217                 printf "$@"
218                 print_subtest
219         }
220 fi
221
222 error () {
223         say_color error "error: $*\n"
224         GIT_EXIT_OK=t
225         exit 1
226 }
227
228 say () {
229         say_color info "$*"
230 }
231
232 test "${test_description}" != "" ||
233 error "Test script did not set test_description."
234
235 if test "$help" = "t"
236 then
237         echo "Tests ${test_description}"
238         exit 0
239 fi
240
241 test_description_printed=
242 print_test_description ()
243 {
244         test -z "$test_description_printed" || return 0
245         echo
246         echo $this_test: "Testing ${test_description}"
247         test_description_printed=1
248 }
249 if [ -z "$NOTMUCH_TEST_QUIET" ]
250 then
251         print_test_description
252 fi
253
254 test_failure=0
255 test_count=0
256 test_fixed=0
257 test_broken=0
258 test_success=0
259
260 declare -a _exit_functions=()
261
262 at_exit_function () {
263         _exit_functions=($1 ${_exit_functions[@]/$1})
264 }
265
266 rm_exit_function () {
267         _exit_functions=(${_exit_functions[@]/$1})
268 }
269
270 _exit_common () {
271         code=$?
272         trap - EXIT
273         set +ex
274         for _fn in ${_exit_functions[@]}; do $_fn; done
275         rm -rf "$TEST_TMPDIR"
276 }
277
278 trap_exit () {
279         _exit_common
280         if test -n "$GIT_EXIT_OK"
281         then
282                 exit $code
283         else
284                 exec >&6
285                 say_color error '%-6s' FATAL
286                 echo " $test_subtest_name"
287                 echo
288                 echo "Unexpected exit while executing $0. Exit code $code."
289                 exit 1
290         fi
291 }
292
293 trap_signal () {
294         _exit_common
295         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
296         exit $code
297 }
298
299 die () {
300         _exit_common
301         exec >&6
302         say_color error '%-6s' FATAL
303         echo " $*"
304         echo
305         echo "Unexpected exit while executing $0."
306         exit 1
307 }
308
309 GIT_EXIT_OK=
310 # Note: TEST_TMPDIR *NOT* exported!
311 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
312 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
313 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
314 trap 'trap_exit' EXIT
315 trap 'trap_signal' HUP INT TERM
316
317 # Deliver a message with emacs and add it to the database
318 #
319 # Uses emacs to generate and deliver a message to the mail store.
320 # Accepts arbitrary extra emacs/elisp functions to modify the message
321 # before sending, which is useful to doing things like attaching files
322 # to the message and encrypting/signing.
323 emacs_deliver_message ()
324 {
325     local subject="$1"
326     local body="$2"
327     shift 2
328     # before we can send a message, we have to prepare the FCC maildir
329     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
330     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
331     local smtp_dummy_pid= smtp_dummy_port=
332     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
333     test -n "$smtp_dummy_pid" || return 1
334     test -n "$smtp_dummy_port" || return 1
335
336     test_emacs \
337         "(let ((message-send-mail-function 'message-smtpmail-send-it)
338                (mail-host-address \"example.com\")
339                (smtpmail-smtp-server \"localhost\")
340                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
341            (notmuch-mua-mail)
342            (message-goto-to)
343            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
344            (message-goto-subject)
345            (insert \"${subject}\")
346            (message-goto-body)
347            (insert \"${body}\")
348            $*
349            (notmuch-mua-send-and-exit))"
350
351     # In case message was sent properly, client waits for confirmation
352     # before exiting and resuming control here; therefore making sure
353     # that server exits by sending (KILL) signal to it is safe.
354     kill -9 $smtp_dummy_pid
355     notmuch new >/dev/null
356 }
357
358 # Pretend to deliver a message with emacs. Really save it to a file
359 # and add it to the database
360 #
361 # Uses emacs to generate and deliver a message to the mail store.
362 # Accepts arbitrary extra emacs/elisp functions to modify the message
363 # before sending, which is useful to doing things like attaching files
364 # to the message and encrypting/signing.
365 #
366 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
367 # at the head of the argument list, they are sent directly to "notmuch
368 # new" after message delivery
369 emacs_fcc_message ()
370 {
371     local nmn_args=''
372     while [[ "$1" =~ ^-- ]]; do
373         nmn_args="$nmn_args $1"
374         shift
375     done
376     local subject="$1"
377     local body="$2"
378     shift 2
379     # before we can send a message, we have to prepare the FCC maildir
380     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
381
382     test_emacs \
383         "(let ((message-send-mail-function (lambda () t))
384                (mail-host-address \"example.com\"))
385            (notmuch-mua-mail)
386            (message-goto-to)
387            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
388            (message-goto-subject)
389            (insert \"${subject}\")
390            (message-goto-body)
391            (insert \"${body}\")
392            $*
393            (notmuch-mua-send-and-exit))" || return 1
394     notmuch new $nmn_args >/dev/null
395 }
396
397 # Add an existing, fixed corpus of email to the database.
398 #
399 # $1 is the corpus dir under corpora to add, using "default" if unset.
400 #
401 # The default corpus is based on about 50 messages from early in the
402 # history of the notmuch mailing list, which allows for reliably
403 # testing commands that need to operate on a not-totally-trivial
404 # number of messages.
405 add_email_corpus ()
406 {
407     corpus=${1:-default}
408
409     rm -rf ${MAIL_DIR}
410     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
411     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
412 }
413
414 test_begin_subtest ()
415 {
416     if [ -n "$inside_subtest" ]; then
417         exec 1>&6 2>&7          # Restore stdout and stderr
418         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
419     fi
420     test_subtest_name="$1"
421     test_reset_state_
422     # Redirect test output to the previously prepared file descriptors
423     # 3 and 4 (see below)
424     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
425     exec >&3 2>&4
426     inside_subtest=t
427 }
428
429 # Pass test if two arguments match
430 #
431 # Note: Unlike all other test_expect_* functions, this function does
432 # not accept a test name. Instead, the caller should call
433 # test_begin_subtest before calling this function in order to set the
434 # name.
435 test_expect_equal ()
436 {
437         exec 1>&6 2>&7          # Restore stdout and stderr
438         if [ -z "$inside_subtest" ]; then
439                 error "bug in the test script: test_expect_equal without test_begin_subtest"
440         fi
441         inside_subtest=
442         test "$#" = 2 ||
443         error "bug in the test script: not 2 parameters to test_expect_equal"
444
445         output="$1"
446         expected="$2"
447         if ! test_skip "$test_subtest_name"
448         then
449                 if [ "$output" = "$expected" ]; then
450                         test_ok_
451                 else
452                         testname=$this_test.$test_count
453                         echo "$expected" > $testname.expected
454                         echo "$output" > $testname.output
455                         test_failure_ "$(diff -u $testname.expected $testname.output)"
456                 fi
457     fi
458 }
459
460 # Like test_expect_equal, but takes two filenames.
461 test_expect_equal_file ()
462 {
463         exec 1>&6 2>&7          # Restore stdout and stderr
464         if [ -z "$inside_subtest" ]; then
465                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
466         fi
467         inside_subtest=
468         test "$#" = 2 ||
469         error "bug in the test script: not 2 parameters to test_expect_equal_file"
470
471         file1="$1"
472         file2="$2"
473         if ! test_skip "$test_subtest_name"
474         then
475                 if diff -q "$file1" "$file2" >/dev/null ; then
476                         test_ok_
477                 else
478                         testname=$this_test.$test_count
479                         basename1=`basename "$file1"`
480                         basename2=`basename "$file2"`
481                         cp "$file1" "$testname.$basename1"
482                         cp "$file2" "$testname.$basename2"
483                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
484                 fi
485     fi
486 }
487
488 # Like test_expect_equal, but arguments are JSON expressions to be
489 # canonicalized before diff'ing.  If an argument cannot be parsed, it
490 # is used unchanged so that there's something to diff against.
491 test_expect_equal_json () {
492     # The test suite forces LC_ALL=C, but this causes Python 3 to
493     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
494     # override Python's stdio encoding defaults.
495     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
496     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
497         || echo "$1")
498     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
499         || echo "$2")
500     shift 2
501     test_expect_equal "$output" "$expected" "$@"
502 }
503
504 # Sort the top-level list of JSON data from stdin.
505 test_sort_json () {
506     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
507         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
508 }
509
510 test_emacs_expect_t () {
511         test "$#" = 1 ||
512         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
513         if [ -z "$inside_subtest" ]; then
514                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
515         fi
516
517         # Run the test.
518         if ! test_skip "$test_subtest_name"
519         then
520                 test_emacs "(notmuch-test-run $1)" >/dev/null
521
522                 # Restore state after the test.
523                 exec 1>&6 2>&7          # Restore stdout and stderr
524                 inside_subtest=
525
526                 # Report success/failure.
527                 result=$(cat OUTPUT)
528                 if [ "$result" = t ]
529                 then
530                         test_ok_
531                 else
532                         test_failure_ "${result}"
533                 fi
534         else
535                 # Restore state after the (non) test.
536                 exec 1>&6 2>&7          # Restore stdout and stderr
537                 inside_subtest=
538         fi
539 }
540
541 NOTMUCH_NEW ()
542 {
543     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
544 }
545
546 NOTMUCH_DUMP_TAGS ()
547 {
548     # this relies on the default format being batch-tag, otherwise some tests will break
549     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
550 }
551
552 notmuch_drop_mail_headers ()
553 {
554     $NOTMUCH_PYTHON -c '
555 import email, sys
556 msg = email.message_from_file(sys.stdin)
557 for hdr in sys.argv[1:]: del msg[hdr]
558 print(msg.as_string(False))
559 ' "$@"
560 }
561
562 notmuch_search_sanitize ()
563 {
564     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
565 }
566
567 notmuch_search_files_sanitize ()
568 {
569     notmuch_dir_sanitize
570 }
571
572 notmuch_dir_sanitize ()
573 {
574     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
575 }
576
577 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
578 notmuch_show_sanitize ()
579 {
580     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
581 }
582 notmuch_show_sanitize_all ()
583 {
584     sed \
585         -e 's| filename:.*| filename:XXXXX|' \
586         -e 's| id:[^ ]* | id:XXXXX |' | \
587         notmuch_date_sanitize
588 }
589
590 notmuch_json_show_sanitize ()
591 {
592     sed \
593         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
594         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
595         -e 's|"filename": "signature.asc",||g' \
596         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
597         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
598         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
599 }
600
601 notmuch_emacs_error_sanitize ()
602 {
603     local command=$1
604     shift
605     for file in "$@"; do
606         echo "=== $file ==="
607         cat "$file"
608     done | sed  \
609         -e 's/^\[.*\]$/[XXX]/' \
610         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
611 }
612
613 notmuch_date_sanitize ()
614 {
615     sed \
616         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
617 }
618
619 notmuch_uuid_sanitize ()
620 {
621     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
622 }
623
624 notmuch_built_with_sanitize ()
625 {
626     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
627 }
628
629 notmuch_config_sanitize ()
630 {
631     notmuch_dir_sanitize | notmuch_built_with_sanitize
632 }
633
634 notmuch_show_part ()
635 {
636     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
637 }
638
639 # End of notmuch helper functions
640
641 # Use test_set_prereq to tell that a particular prerequisite is available.
642 #
643 # The prerequisite can later be checked for by using test_have_prereq.
644 #
645 # The single parameter is the prerequisite tag (a simple word, in all
646 # capital letters by convention).
647
648 test_set_prereq () {
649         satisfied="$satisfied$1 "
650 }
651 satisfied=" "
652
653 test_have_prereq () {
654         case $satisfied in
655         *" $1 "*)
656                 : yes, have it ;;
657         *)
658                 ! : nope ;;
659         esac
660 }
661
662 declare -A test_missing_external_prereq_
663 declare -A test_subtest_missing_external_prereq_
664
665 # declare prerequisite for the given external binary
666 test_declare_external_prereq () {
667         binary="$1"
668         test "$#" = 2 && name=$2 || name="$binary(1)"
669
670         if ! hash $binary 2>/dev/null; then
671                 test_missing_external_prereq_["${binary}"]=t
672                 eval "
673 $binary () {
674         test_subtest_missing_external_prereq_[\"${name}\"]=t
675         false
676 }"
677         fi
678 }
679
680 # Explicitly require external prerequisite.  Useful when binary is
681 # called indirectly (e.g. from emacs).
682 # Returns success if dependency is available, failure otherwise.
683 test_require_external_prereq () {
684         binary="$1"
685         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
686                 # dependency is missing, call the replacement function to note it
687                 eval "$binary"
688         else
689                 true
690         fi
691 }
692
693 # You are not expected to call test_ok_ and test_failure_ directly, use
694 # the text_expect_* functions instead.
695
696 test_ok_ () {
697         if test "$test_subtest_known_broken_" = "t"; then
698                 test_known_broken_ok_
699                 return
700         fi
701         test_success=$(($test_success + 1))
702         if test -n "$NOTMUCH_TEST_QUIET"; then
703                 return 0
704         fi
705         say_color pass "%-6s" "PASS"
706         echo " $test_subtest_name"
707 }
708
709 test_failure_ () {
710         print_test_description
711         if test "$test_subtest_known_broken_" = "t"; then
712                 test_known_broken_failure_ "$@"
713                 return
714         fi
715         test_failure=$(($test_failure + 1))
716         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
717         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
718         return 1
719 }
720
721 test_failure_message_ () {
722         say_color error "%-6s" "$1"
723         echo " $2"
724         shift 2
725         if [ "$#" != "0" ]; then
726                 echo "$@" | sed -e 's/^/        /'
727         fi
728         if test "$verbose" != "t"; then cat test.output; fi
729 }
730
731 test_known_broken_ok_ () {
732         test_reset_state_
733         test_fixed=$(($test_fixed+1))
734         say_color pass "%-6s" "FIXED"
735         echo " $test_subtest_name"
736 }
737
738 test_known_broken_failure_ () {
739         test_reset_state_
740         test_broken=$(($test_broken+1))
741         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
742                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
743         else
744                 test_failure_message_ "BROKEN" "$test_subtest_name"
745         fi
746         return 1
747 }
748
749 test_debug () {
750         test "$debug" = "" || eval "$1"
751 }
752
753 test_run_ () {
754         test_cleanup=:
755         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
756         eval >&3 2>&4 "$1"
757         eval_ret=$?
758         eval >&3 2>&4 "$test_cleanup"
759         return 0
760 }
761
762 test_skip () {
763         test_count=$(($test_count+1))
764         to_skip=
765         for skp in $NOTMUCH_SKIP_TESTS
766         do
767                 case $this_test.$test_count in
768                 $skp)
769                         to_skip=t
770                         break
771                 esac
772                 case $this_test_bare.$test_count in
773                 $skp)
774                         to_skip=t
775                         break
776                 esac
777         done
778         case "$to_skip" in
779         t)
780                 test_report_skip_ "$@"
781                 ;;
782         *)
783                 test_check_missing_external_prereqs_ "$@"
784                 ;;
785         esac
786 }
787
788 test_check_missing_external_prereqs_ () {
789         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
790                 say_color skip >&1 "missing prerequisites: "
791                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
792                 test_report_skip_ "$@"
793         else
794                 false
795         fi
796 }
797
798 test_report_skip_ () {
799         test_reset_state_
800         say_color skip >&3 "skipping test:"
801         echo " $@" >&3
802         say_color skip "%-6s" "SKIP"
803         echo " $1"
804 }
805
806 test_subtest_known_broken () {
807         test_subtest_known_broken_=t
808 }
809
810 test_expect_success () {
811         exec 1>&6 2>&7          # Restore stdout and stderr
812         if [ -z "$inside_subtest" ]; then
813                 error "bug in the test script: test_expect_success without test_begin_subtest"
814         fi
815         inside_subtest=
816         test "$#" = 1 ||
817         error "bug in the test script: not 1 parameters to test_expect_success"
818
819         if ! test_skip "$test_subtest_name"
820         then
821                 test_run_ "$1"
822                 run_ret="$?"
823                 # test_run_ may update missing external prerequisites
824                 test_check_missing_external_prereqs_ "$@" ||
825                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
826                 then
827                         test_ok_
828                 else
829                         test_failure_ "$1"
830                 fi
831         fi
832 }
833
834 test_expect_code () {
835         exec 1>&6 2>&7          # Restore stdout and stderr
836         if [ -z "$inside_subtest" ]; then
837                 error "bug in the test script: test_expect_code without test_begin_subtest"
838         fi
839         inside_subtest=
840         test "$#" = 2 ||
841         error "bug in the test script: not 2 parameters to test_expect_code"
842
843         if ! test_skip "$test_subtest_name"
844         then
845                 test_run_ "$2"
846                 run_ret="$?"
847                 # test_run_ may update missing external prerequisites,
848                 test_check_missing_external_prereqs_ "$@" ||
849                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
850                 then
851                         test_ok_
852                 else
853                         test_failure_ "exit code $eval_ret, expected $1" "$2"
854                 fi
855         fi
856 }
857
858 # This is not among top-level (test_expect_success)
859 # but is a prefix that can be used in the test script, like:
860 #
861 #       test_expect_success 'complain and die' '
862 #           do something &&
863 #           do something else &&
864 #           test_must_fail git checkout ../outerspace
865 #       '
866 #
867 # Writing this as "! git checkout ../outerspace" is wrong, because
868 # the failure could be due to a segv.  We want a controlled failure.
869
870 test_must_fail () {
871         "$@"
872         test $? -gt 0 -a $? -le 129 -o $? -gt 192
873 }
874
875 # test_cmp is a helper function to compare actual and expected output.
876 # You can use it like:
877 #
878 #       test_expect_success 'foo works' '
879 #               echo expected >expected &&
880 #               foo >actual &&
881 #               test_cmp expected actual
882 #       '
883 #
884 # This could be written as either "cmp" or "diff -u", but:
885 # - cmp's output is not nearly as easy to read as diff -u
886 # - not all diff versions understand "-u"
887
888 test_cmp() {
889         $GIT_TEST_CMP "$@"
890 }
891
892 # This function can be used to schedule some commands to be run
893 # unconditionally at the end of the test to restore sanity:
894 #
895 #       test_expect_success 'test core.capslock' '
896 #               git config core.capslock true &&
897 #               test_when_finished "git config --unset core.capslock" &&
898 #               hello world
899 #       '
900 #
901 # That would be roughly equivalent to
902 #
903 #       test_expect_success 'test core.capslock' '
904 #               git config core.capslock true &&
905 #               hello world
906 #               git config --unset core.capslock
907 #       '
908 #
909 # except that the greeting and config --unset must both succeed for
910 # the test to pass.
911
912 test_when_finished () {
913         test_cleanup="{ $*
914                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
915 }
916
917 test_done () {
918         GIT_EXIT_OK=t
919         test_results_dir="$TEST_DIRECTORY/test-results"
920         mkdir -p "$test_results_dir"
921         test_results_path="$test_results_dir/$this_test"
922
923         echo "total $test_count" >> $test_results_path
924         echo "success $test_success" >> $test_results_path
925         echo "fixed $test_fixed" >> $test_results_path
926         echo "broken $test_broken" >> $test_results_path
927         echo "failed $test_failure" >> $test_results_path
928         echo "" >> $test_results_path
929
930         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
931
932         if [ "$test_failure" = "0" ]; then
933             if [ "$test_broken" = "0" ]; then
934                 rm -rf "$remove_tmp"
935             fi
936             exit 0
937         else
938             exit 1
939         fi
940 }
941
942 emacs_generate_script () {
943         # Construct a little test script here for the benefit of the user,
944         # (who can easily run "run_emacs" to get the same emacs environment
945         # for investigating any failures).
946         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
947 #!/bin/sh
948 export PATH=$PATH
949 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
950
951 # Here's what we are using here:
952 #
953 # --quick              Use minimal customization. This implies --no-init-file,
954 #                      --no-site-file and (emacs 24) --no-site-lisp
955 #
956 # --directory           Ensure that the local elisp sources are found
957 #
958 # --load                Force loading of notmuch.el and test-lib.el
959
960 exec ${TEST_EMACS} --quick \
961         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
962         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
963         "\$@"
964 EOF
965         chmod a+x "$TMP_DIRECTORY/run_emacs"
966 }
967
968 test_emacs () {
969         # test dependencies beforehand to avoid the waiting loop below
970         missing_dependencies=
971         test_require_external_prereq dtach || missing_dependencies=1
972         test_require_external_prereq emacs || missing_dependencies=1
973         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
974         test -z "$missing_dependencies" || return
975
976         if [ -z "$EMACS_SERVER" ]; then
977                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
978                 if [ -f "$emacs_tests" ]; then
979                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
980                 else
981                         load_emacs_tests=
982                 fi
983                 server_name="notmuch-test-suite-$$"
984                 # start a detached session with an emacs server
985                 # user's TERM (or 'vt100' in case user's TERM is known dumb
986                 # or unknown) is given to dtach which assumes a minimally
987                 # VT100-compatible terminal -- and emacs inherits that
988                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
989                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
990                                 --no-window-system \
991                                 $load_emacs_tests \
992                                 --eval '(setq server-name \"$server_name\")' \
993                                 --eval '(server-start)' \
994                                 --eval '(orphan-watchdog $$)'" || return
995                 EMACS_SERVER="$server_name"
996                 # wait until the emacs server is up
997                 until test_emacs '()' >/dev/null 2>/dev/null; do
998                         sleep 1
999                 done
1000         fi
1001
1002         # Clear test-output output file.  Most Emacs tests end with a
1003         # call to (test-output).  If the test code fails with an
1004         # exception before this call, the output file won't get
1005         # updated.  Since we don't want to compare against an output
1006         # file from another test, so start out with an empty file.
1007         rm -f OUTPUT
1008         touch OUTPUT
1009
1010         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1011 }
1012
1013 test_python() {
1014     # Note: if there is need to print debug information from python program,
1015     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1016     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1017         $NOTMUCH_PYTHON -B - > OUTPUT
1018 }
1019
1020 test_ruby() {
1021     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1022 }
1023
1024 test_C () {
1025     exec_file="test${test_count}"
1026     test_file="${exec_file}.c"
1027     cat > ${test_file}
1028     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1029     echo "== stdout ==" > OUTPUT.stdout
1030     echo "== stderr ==" > OUTPUT.stderr
1031     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1032     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1033 }
1034
1035
1036 # Creates a script that counts how much time it is executed and calls
1037 # notmuch.  $notmuch_counter_command is set to the path to the
1038 # generated script.  Use notmuch_counter_value() function to get the
1039 # current counter value.
1040 notmuch_counter_reset () {
1041         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1042         if [ ! -x "$notmuch_counter_command" ]; then
1043                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1044                 cat >"$notmuch_counter_command" <<EOF || return
1045 #!/bin/sh
1046
1047 read count < "$notmuch_counter_state_path"
1048 echo \$((count + 1)) > "$notmuch_counter_state_path"
1049
1050 exec notmuch "\$@"
1051 EOF
1052                 chmod +x "$notmuch_counter_command" || return
1053         fi
1054
1055         echo 0 > "$notmuch_counter_state_path"
1056 }
1057
1058 # Returns the current notmuch counter value.
1059 notmuch_counter_value () {
1060         if [ -r "$notmuch_counter_state_path" ]; then
1061                 read count < "$notmuch_counter_state_path"
1062         else
1063                 count=0
1064         fi
1065         echo $count
1066 }
1067
1068 test_reset_state_ () {
1069         test -z "$test_init_done_" && test_init_
1070
1071         test_subtest_known_broken_=
1072         test_subtest_missing_external_prereq_=()
1073 }
1074
1075 # called once before the first subtest
1076 test_init_ () {
1077         test_init_done_=t
1078
1079         # skip all tests if there were external prerequisites missing during init
1080         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1081 }
1082
1083
1084 # Where to run the tests
1085 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1086
1087 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1088
1089 emacs_generate_script
1090
1091
1092 # Use -P to resolve symlinks in our working directory so that the cwd
1093 # in subprocesses like git equals our $PWD (for pathname comparisons).
1094 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1095
1096 if test "$verbose" = "t"
1097 then
1098         exec 4>&2 3>&1
1099 else
1100         exec 4>test.output 3>&4
1101 fi
1102
1103 for skp in $NOTMUCH_SKIP_TESTS
1104 do
1105         to_skip=
1106         for skp in $NOTMUCH_SKIP_TESTS
1107         do
1108                 case "$this_test" in
1109                 $skp)
1110                         to_skip=t
1111                         break
1112                 esac
1113                 case "$this_test_bare" in
1114                 $skp)
1115                         to_skip=t
1116                         break
1117                 esac
1118         done
1119         case "$to_skip" in
1120         t)
1121                 say_color skip >&3 "skipping test $this_test altogether"
1122                 say_color skip "skip all tests in $this_test"
1123                 test_done
1124         esac
1125 done
1126
1127 # Provide an implementation of the 'yes' utility
1128 yes () {
1129         if test $# = 0
1130         then
1131                 y=y
1132         else
1133                 y="$*"
1134         fi
1135
1136         while echo "$y"
1137         do
1138                 :
1139         done
1140 }
1141
1142 # Fix some commands on Windows
1143 case $(uname -s) in
1144 *MINGW*)
1145         # Windows has its own (incompatible) sort and find
1146         sort () {
1147                 /usr/bin/sort "$@"
1148         }
1149         find () {
1150                 /usr/bin/find "$@"
1151         }
1152         sum () {
1153                 md5sum "$@"
1154         }
1155         # git sees Windows-style pwd
1156         pwd () {
1157                 builtin pwd -W
1158         }
1159         # no POSIX permissions
1160         # backslashes in pathspec are converted to '/'
1161         # exec does not inherit the PID
1162         ;;
1163 *)
1164         test_set_prereq POSIXPERM
1165         test_set_prereq BSLASHPSPEC
1166         test_set_prereq EXECKEEPSPID
1167         ;;
1168 esac
1169
1170 test -z "$NO_PERL" && test_set_prereq PERL
1171 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1172
1173 # test whether the filesystem supports symbolic links
1174 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1175 rm -f y
1176
1177 # convert variable from configure to more convenient form
1178 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1179     glass)
1180         db_ending=glass
1181     ;;
1182     chert)
1183         db_ending=DB
1184     ;;
1185     *)
1186         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1187 esac
1188 # declare prerequisites for external binaries used in tests
1189 test_declare_external_prereq dtach
1190 test_declare_external_prereq emacs
1191 test_declare_external_prereq ${TEST_EMACSCLIENT}
1192 test_declare_external_prereq ${TEST_GDB}
1193 test_declare_external_prereq gpg
1194 test_declare_external_prereq openssl
1195 test_declare_external_prereq gpgsm
1196 test_declare_external_prereq ${NOTMUCH_PYTHON}